#include "include/I3E_CTS.hpp"
#include "include/I3E_DAG.hpp"

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

/**********************************************************************************************************************
 * @cond                                               FILE SCOPE                                              @endcond
/*********************************************************************************************************************/

FileScop pthread_mutex_t mtx_timeSync;

FileScop SE_TimeType_t i3e_syncServerTime;
FileScop SE_TimeType_t i3e_syncClientTime; 

/**********************************************************************************************************************
 * @cond                                              MODULE SCOPE                                             @endcond
/*********************************************************************************************************************/

ModScop int I3E_CTS_Init(void)
{
    StackScop int res = pthread_mutex_init(&mtx_timeSync, NULL);
    return res;
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

// Function to update the synchronized times 
ModScop void I3E_CTS_SyncTime(void)
{
    StackScop Graph* i3e_dagResources = I3E_SPP_GetDAG();
 
    pthread_mutex_lock(&mtx_timeSync);

    // Get system time
    StackScop timespec str_sysTime; 
    clock_gettime(CLOCK_BOOTTIME, &str_sysTime);
    i3e_syncClientTime = (SE_TimeType_t)str_sysTime.tv_sec;
    
    // Get server time 
    StackScop std::string sz_timeHref = (i3e_dagResources->I3E_DAG_FindResourceNodes(TM)).at(0); 
    StackScop NodeData str_timeNode = i3e_dagResources->I3E_DAG_GetNode(sz_timeHref);
    StackScop SE_Time_t& i3e_time = std::get<SE_Time_t>(str_timeNode.var_rsrc);
    i3e_syncServerTime = i3e_time.currentTime;

    pthread_mutex_unlock(&mtx_timeSync);
    
}

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ModScop SE_TimeType_t I3E_CTS_getSyncTime(void) 
{
    pthread_mutex_lock(&mtx_timeSync);

    StackScop timespec str_cliTime; 
    clock_gettime(CLOCK_BOOTTIME, &str_cliTime);
    
    // Calculate the synchronized time
    StackScop SE_TimeType_t i3e_lastSyncTime = (SE_TimeType_t)str_cliTime.tv_sec - i3e_syncClientTime;
    StackScop SE_TimeType_t i3e_syncTime = i3e_lastSyncTime + i3e_syncServerTime;

    pthread_mutex_unlock(&mtx_timeSync);

    return i3e_syncTime;
}