/**********************************************************************************************************************
* @file            CST_IAL.h
*
* @brief           This module defines the IAL interface for the CST module. 
*
* @author          Vlad Bugayev
* @date            12/9/2024
* @copyright       2024 Lion Energy LLC.
*                  All rights reserved
*
*********************************************************************************************************************/
/**
* @addtogroup      CST
*                  Identifier Description for the CST Module  
* 
* @ref             CST_IAL.h 
*                  
*********************************************************************************************************************/
#include "COD_Compiler_Defines.h"

#ifndef LION_CST_IAL_H__
#define LION_CST_IAL_H__

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#ifdef __cplusplus
extern "C"
{
#endif

/*********************************************************************************************************************
* @cond                                              MODULE SCOPE                                             @endcond
*********************************************************************************************************************/

/**
 * @brief Initialization function for the IMC-IAL. 
 * 
 * @details Performs registration of callback functions with the IAL module.
 */
ModScop void CST_IAL_Init();


#ifdef __cplusplus
}
#endif

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#endif // LION_CST_IAL_H__
//EOF