#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <systemd/sd-daemon.h>

#include <lion/ICC_Client.h>
#include <lion/ial/IAL.h>
#include <lion/I3E.h>
#include <lion/VRS.h>
#include "app_version.h"

#define STRINGIFY(X) __STRING(X)

ICC_Context_t *ptr_IccCtx = NULL;

int main(int argc, char *argv[])
{
    printf("Program Started v" APP_VERSION_STRING " [" STRINGIFY(APP_BUILD_VERSION) "]\n");

    ptr_IccCtx = ICC_Client_Init(NULL);
    ICC_Client_Start(RTOS_SECONDS(3));

    IAL_Init(ptr_IccCtx);

    VRS_Init(NULL);
    VRS_Start();
    I3E_Init();

    while (1)
    {
        sleep(1);
        sd_notify(0, "WATCHDOG=1"); /* Feed the Hungry Watchdog */
        fflush(stdout);
    }

    return 0;
}